/*                                                                           *
 * load.c is used to load executable code into the DSP from an s-record file *
 *                                                                           */

/*=============== included files ============================================*/
#include <stdio.h>
#include <sys/types.h>
#include <sys/termios.h>
#include <sys/time.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include "dspdvr.h"

/*===== Main program ========================================================*/
main(char argc, char** argv)
{
    FILE *fp;
    char *srec_file;
    char opt[8];
    int srec_count=0;
    int init=0;

    argv++ ;
    if (*argv == NULL) {
        printf("Input file name required \n");
        exit(0);
    }

    if (argc == 2){
        init=2;
    }

    if (argc == 3){
        if(strncmp(*argv,"-f",2) == 0) {
            printf("%s\n",*argv);
            printf("found -f\n");
            init = 2;
        }

        if(strncmp(*argv,"-w",2) == 0) {
            printf("%s\n",*argv);
            printf("found -w\n");
            init = 1;
        }
        argv++;
    }
        

    srec_file = *argv;
    if(strchr(srec_file,'.')==NULL) strcat(srec_file,".s");

    printf ("S-rec file = %s\n", srec_file);

    dsp_open();

    if (init == 1){
        dsp_init(srec_file);
    }
    else {
        dsp_initII(srec_file);
    }

    dsp_close();
    exit(0);
}

