/*=============== d4link.c ====================================================*/
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include "dspdvr.h"

#define  NBLOCKS        1
#define  BSIZE          2048

//static char srec_file[] = "slink.s";

/*===== Main program ========================================================*/
main() {
    u_char cmd=0;

    int i=0,j=0,r=0,w=0, rval=0, sval=0;
    int rc=0, wc=0, ec=0, err=0;
    int hist[16];
    int wbuf[BSIZE], rbuf[BSIZE];

    dsp_open();
#if (INIT==1)                   // INIT is passed from the makefile
    r=dsp_init("slink.s");
#endif // INIT

#if (INIT==2)
    r=dsp_initII("flink.s");
#endif // INIT

    if (r<0)exit(0);

    srand(time(NULL));

    while (cmd != 'q'){
        fprintf(stdout,"\n");
        fprintf(stdout,"cmd>");
        fscanf(stdin,"%s",&cmd);

        switch(cmd){
        case 's':
        dsp_clear_fifo();
        udelay(1);
        dsp_write16(sval);
        r = dsp_read16(&rval);
        printf("r= %02x sval= %06x   rval= %06x\n", r,sval,rval);
        sval+=1;
        break;

        case 'a':           /* write, then read a small buffer */
        r=dsp_clear_fifo();
        for (j=0; j<16; j++) hist[j] = 0;
        wc = 0;
        rc = 0;
        err = 0;
        for (r=0; r<BSIZE; r++){
            wbuf[r] = (int) (r & 0xff | (r&0xff)<<8);
            rbuf[r] = 0;
        }
        for(j=0; j<BSIZE; j++){
            r = dsp_write16(wbuf[j]);
            if (r>0)wc+=r;
        }
        for(j=0; j<BSIZE; j++){
            r = dsp_read16(&rbuf[j]);
            if (r>0)rc+=r;
        }

        /* Check to see if read and write buffers are identical. */
        /* Print the read and write buffers. */
        /* Make a histogram of bits received. */
        printf("\n");
        for (j=0; j<32; j+=2){
            printf("wbuf %04x %04x   rbuf %04x %04x\n",
                 wbuf[j],wbuf[j+1],rbuf[j],rbuf[j+1]);
        }
        for (j=0; j<BSIZE; j++){
            if (wbuf[j] != rbuf[j]) err++;
        }
        printf("w %04d  r %04d  errors %d\n",wc,rc,err);
        for (j=0; j<16; j++) hist[j] = 0;
        for (i=0; i<BSIZE; i++){
            for (j=0; j<16; j++){
                if (rbuf[i] & (0x1<<j)) hist[j]++;
            }
        }
        for (j=0; j<16; j++){
            printf("%4d ",hist[j]);
            if (j==7 || j==15)printf("\n");
        }
        break;

        case 'b':           /* write, then read a small buffer */
        r = dsp_clear_fifo();
        wc=0;
        rc=0;
        err=0;
        for (r=0; r<BSIZE; r++){
            wbuf[r] = (int) (rand() & 0xffff);
            rbuf[r] = 0;
        }
        for(j=0; j<BSIZE; j++){
            r = dsp_write16(wbuf[j]);
            udelay(1);
            if (r>0)wc+=r;
        }
        for(j=0; j<BSIZE; j++){
            r = dsp_read16(&rbuf[j]);
            if (r>0)rc+=r;
        }

        /* Check to see if read and write buffers are identical */
        /* Print the read and write buffers (should be identical) */
        /* Make a histogram of bits received */
        printf("\n");
        for (j=0; j<32; j+=2){
            printf("wbuf %04x %04x   rbuf %04x %04x\n",
                 wbuf[j],wbuf[j+1],rbuf[j],rbuf[j+1]);
        }
        for (j=0; j<BSIZE; j++){
            if (wbuf[j] != rbuf[j]) err++;
        }
        printf("w %04d  r %04d  errors %d\n",wc,rc,err);
        for (j=0; j<16; j++) hist[j] = 0;
        for (i=0; i<BSIZE; i++){
            for (j=0; j<16; j++){
                if (rbuf[i] & (0x1<<j)) hist[j]++;
            }
        }
        for (j=0; j<16; j++){
            printf("%4d ",hist[j]);
            if (j==7 || j==15)printf("\n");
        }
        break;


        case 'p':           /* write, then read a small buffer */
        r=dsp_clear_fifo();
        for (j=0; j<16; j++) hist[j] = 0;
        wc = 0;
        rc = 0;
        err = 0;
        for (r=0; r<BSIZE; r++){
            wbuf[r] = (int) (r & 0xff | (r&0xff)<<8);
            rbuf[r] = 0;
        }
        for(j=0; j<BSIZE; j++){
            r=dsp_clear_fifo();
            r = dsp_write16(wbuf[j]);
            if (r>0)wc+=r;
            udelay(1);
            r = dsp_read16(&rbuf[j]);
            if (r>0)rc+=r;
        }

        /* Check to see if read and write buffers are identical. */
        /* Print the read and write buffers. */
        /* Make a histogram of bits received. */
        printf("\n");
        for (j=0; j<32; j+=2){
            printf("wbuf %04x %04x   rbuf %04x %04x\n",
                 wbuf[j],wbuf[j+1],rbuf[j],rbuf[j+1]);
        }
        for (j=0; j<BSIZE; j++){
            if (wbuf[j] != rbuf[j]) err++;
        }
        printf("w %04d  r %04d  errors %d\n",wc,rc,err);
        for (j=0; j<16; j++) hist[j] = 0;
        for (i=0; i<BSIZE; i++){
            for (j=0; j<16; j++){
                if (rbuf[i] & (0x1<<j)) hist[j]++;
            }
        }
        for (j=0; j<16; j++){
            printf("%4d ",hist[j]);
            if (j==7 || j==15)printf("\n");
        }
        break;

        default:
            break;
        }

    }
    dsp_close();
    exit(0);
}
